'Test of the Propeller time driver
'Copyright 2008 Raymond Allen

CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency


OBJ  'Objects Section
    'We need the VGA (or TV) text driver
    
 text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).
 Time : "PropTime" 


PUB MAIN|i    'the first PUB routine is assumed the be the main one
  
  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video

  Time.start     'Start the Time driver. (uses one cog)
  

  'Set current time
  Time.SetLocalTime(9, 3, 2008, 15, 55, 00)  '(month, day, year, hours, minutes,seconds) 
  
  'Or, set test time to look at an interesting time... 
  'TimeTest(1)   'try one of these tests (1..10)
  

  'show time
   repeat  
     text.str(string($B,$2,$A))
     text.out(0)
     'get time
     if (NOT Time.Time)
       text.str(string("Error Reading RTC.",13))
       quit
     text.str(String("Local Time",13))  
     text.str(Time.StrTime(1))
     text.out(13)
     text.out(13)
     text.str(String("Unix Time",13))  
     text.str(Time.StrTime(2))
     text.out(13)
     text.out(13)
     text.str(String("C Time",13))  
     text.str(Time.StrTime(3))
     text.out(13)
     text.out(13)
     text.str(String("GMT",13))  
     text.str(Time.StrTime(4))
     text.out(13)


     
Pub TimeTest(n)|zone
  'Examples (or tests...):
  'set time zone
  zone:=5    '5==USA\New York .. 8==USA\Los Angeles
  Time.SetTimeZone(zone)
  text.out(0)
  Case n
    1:
      'just before DST starts:  Time jumps ahead one hour
      text.str(string("Just before DST Started:"))
      'Time.SetLocalTime(3, 11, 2007, 1, 59, 50)  '(month, day, year, hours, minutes,seconds)
      Time.SetLocalTime(3, 8, 2009, 1, 59, 50)  '(month, day, year, hours, minutes,seconds) 
    2:
      'just after DST starts:  
      text.str(string("Just after DST Started:"))
      'Time.SetLocalTime(3, 11, 2007, 3, 01, 00)  '(month, day, year, hours, minutes,seconds)
      Time.SetLocalTime(3, 8, 2009, 1, 59, 50)  '(month, day, year, hours, minutes,seconds) 
    3:
      'just before DST ends  'Hard to set this because this hour exists twice!
      text.str(string("Just before DST ends:"))
        'First, set two hours before ends
      'Time.SetLocalTime(11, 4, 2007, 0, 59, 50)  '(month, day, year, hours, minutes,seconds)
      Time.SetLocalTime(11, 2, 2008, 0, 59, 50)  '(month, day, year, hours, minutes,seconds)   
        'Then, add two hours
      Time.SetUnixTime(Time.time+Time#secondsperhour*2)
    4:
      'Setting a time in GMT via data/time
      'GMT:  Sun, 11 Mar 2007 00:59:50 UTC
      text.str(string("Some day in March:"))
      Time.SetGmtTime(3,11,2007,0,59,50)  '(month, day, year, hours, minutes,seconds)
    5: 
      'Setting a time in GMT via unix time
      text.str(string("Testing Day:"))
      Time.SetUnixTime(1196100282)
    6:
      'Last month, day, hour
      text.str(string("Lasts:"))
      Time.SetUnixTime(1198972790)
      Time.SetUnixTime(Time.time+Time#secondsperhour*zone)   'assuming EST
    7:
     'End of year
      text.str(string("New Year:"))
      Time.SetUnixTime(1199145590)
      Time.SetUnixTime(Time.time+Time#secondsperhour*zone)   'assuming EST
    8:
      'Y2K38 Problem
      text.str(string("Year 2038 Problem"))
      Time.SetUnixTime($7FFF_FFFA) 'This actually keeps going!  But, try to set a date in 2038!
    9:
      'UTC 1234567890
      text.str(string("UTC 1234567890"))
      Time.SetUnixTime(1234567880)
    10:
      'UTC 2000000000
      text.str(string("Second Billennium"))
      Time.SetUnixTime(1999999990)            
        
      
      
       
           